{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

Author:       Franois PIETTE
Description:  Example of server object accessing a TTable and using UserData
              Part of the SrvTst sample application server.
Creation:     March 4, 1998
Version:      1.03
EMail:        http://www.overbyte.be        http://www.rtfm.be/fpiette
              francois.piette@overbyte.be   francois.piette@rtfm.be
                                            francois.piette@pophost.eunet.be
Support:      Use the mailing list midware@elists.org
              Follow "support" link at http://www.overbyte.be for subscription.
Legal issues: Copyright (C) 1998-2002 by Franois PIETTE
              Rue de Grady 24, 4053 Embourg, Belgium. Fax: +32-4-365.74.56
              <francois.piette@overbyte.be>

              This software is provided 'as-is', without any express or
              implied warranty. In no event will the author be held liable
              for any damages arising from the use of this software.

              Permission is granted to anyone to use this software and or any
              derived or altered versions for any purpose, excluding commercial
              applications. You can use this software for personal use only.
              You may distribute it freely untouched.
              The following restrictions applies:

              1. The origin of this software must not be misrepresented, you
                 must not claim that you wrote the original software.

              2. If you use this software in a product, an acknowledgment in
                 the product documentation and displayed on screen is required.
                 The text must be: "This product is based on MidWare. Freeware
                 source code is available at http://www.overbyte.be."

              3. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              4. This notice may not be removed or altered from any source
                 distribution and must be added to the product documentation.

Updates:
May 23, 1998  V1.01 Changed table layout to use english names for columns.
Jun 20, 1998  V1.02 Added support for datetime fields
Jul 08, 1998  V1.03 Simplified code because WriteFields now support TField

 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
unit SrvObj3;

interface
uses
    SysUtils, RBroker, RFormat, SrvTst2, Classes, Db;

const
    VersionServerObjectGETCLIENT = 103;

type
    TServerObjectGETCLIENT = class(TServerObject)
    public
        procedure Execute; override;
    end;

procedure Register;

implementation


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure Register;
begin
    RegisterComponents('FPiette', [TServerObjectGETCLIENT]);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TServerObjectGETCLIENT.Execute;
var
    UData : PUserDataRecord;
    Fld   : Integer;
    Key   : String;
begin
    UData                 := PUserDataRecord(FUserData);
    UData.CliTable.Active := TRUE;

    Key := UpperCase(FRequestBuffer.Fields[0]);
    UData.CliTable.IndexName := 'LAST';
    UData.CliTable.SetKey;
    UData.CliTable.FieldByName('LAST').AsString := Key;
    if UData.CliTable.GotoKey then begin
        { Data found }
        FResultStatus := 200;
        { Copy all fields from the table to the response set }
        for Fld := 0 to UData.CliTable.FieldCount - 1 do
            FResponseBuffer.WriteFields(FALSE, [UData.CliTable.Fields[Fld]]);
    end
    else begin
        { Data not found }
        FResultStatus := 400;
        FResponseBuffer.WriteFields(FALSE, [Key, 'not found']);
    end;

    Finish;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

end.


