{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

Author:       Franois Piette
Description:  Demo for TMWTrackDataSet component
Creation:     Feb 23, 2002
Version:      1.00
EMail:        francois.piette@overbyte.be   francois.piette@rtfm.be
              http://www.overbyte.be        http://www.rtfm.be/fpiette
              francois.piette@pophost.eunet.be
Support:      Use the mailing list midware@elists.org
              Follow "support" link at http://www.overbyte.be for subscription.
Legal issues: Copyright (C) 2002 by Franois PIETTE
              Rue de Grady 24, 4053 Embourg, Belgium. Fax: +32-4-365.74.56
              <francois.piette@overbyte.be> <francois.piette@pophost.eunet.be>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software and or any
              derived or altered versions for any purpose, excluding commercial
              applications. You can use this software for personal use only.
              You may distribute it freely untouched.
              The following restrictions applies:

              1. The origin of this software must not be misrepresented, you
                 must not claim that you wrote the original software.

              2. If you use this software in a product, an acknowledgment in
                 the product documentation and displayed on screen is required.
                 The text must be: "This product is based on MidWare. Freeware
                 source code is available at http://www.overbyte.be."

              3. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              4. This notice may not be removed or altered from any source
                 distribution and must be added to the product documentation.


Updates:


 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
unit TrackTst1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, TrackDs, RFormat, MwDatSet, ExtCtrls,
  DBCtrls, StdCtrls, MWTrack;

type
  TTrackTstForm = class(TForm)
    MWTable1: TMWTable;
    MWBuffer1: TMWBuffer;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Memo1: TMemo;
    MWTrackDataSet1: TMWTrackDataSet;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    OpenTableButton: TButton;
    ClearTableButton: TButton;
    DisplayTrackDataButton: TButton;
    procedure DisplayTrackDataButtonClick(Sender: TObject);
    procedure OpenTableButtonClick(Sender: TObject);
    procedure ClearTableButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TrackTstForm: TTrackTstForm;

implementation

{$R *.dfm}

procedure TTrackTstForm.DisplayTrackDataButtonClick(Sender: TObject);
begin
    Memo1.Clear;
    MWTrackDataSet1.Data.First;
    while not MWTrackDataSet1.Data.Eof do begin
        Memo1.Lines.Add(MWTrackDataSet1.Data.RecordToString);
        MWTrackDataSet1.Data.Next;
    end;
end;

procedure TTrackTstForm.OpenTableButtonClick(Sender: TObject);
begin
    MWTable1.Active        := TRUE;
    MWTrackDataSet1.Active := TRUE;
end;

procedure TTrackTstForm.ClearTableButtonClick(Sender: TObject);
begin
    MWTrackDataSet1.Active := FALSE;
    MWTable1.Active        := FALSE;
    MWTrackDataSet1.Data.Rewrite;
    MWTable1.Data.Rewrite;
    MWTable1.Active        := TRUE;
    MWTrackDataSet1.Active := TRUE;
end;

end.
